<template>
	<div style="width:100%">
		<mind-layout-table :data="ListaRecursos" rowKey="fullpath" @filter="fetch" @filter-reset="resetFiltro"
			v-loading="loading"
			:action-add="false" :action-edit="false"
			:path="$route.path" @delete="onDelete" >
				<template v-slot:actions="{selectedRow}">
					<el-button type="primary" 
						icon="el-icon-upload2" 
						size="small" 
						@click="dialogVisible = true">Subir Audios
					</el-button>
					<el-button type="primary" 
						icon="el-icon-download" 
						size="small" :disabled="!selectedRow"
						@click="onDownload(selectedRow)">Descargar
					</el-button>
					<!-- <el-button type="primary" 
						icon="el-icon-caret-right" 
						size="small" :disabled="!selectedRow"
						@click="onPlay(selectedRow)">Reproducir</el-button> -->

				</template>
				<template slot="filter">
					<el-row  >
						<el-col  :xs="24"  :lg="12">
							<el-form-item label="Carpeta">
								<el-radio-group v-model="filtros.folder"  size="small" >
									<el-radio-button  label="custom"  >Custom</el-radio-button>
									<el-radio-button label="" >Todos</el-radio-button>
								</el-radio-group>
							</el-form-item>
						</el-col>
					</el-row>
					<el-row  >
						<el-col  :xs="24" :lg="12">
							<el-form-item label="Nombre">
								<el-input v-model="filtros.name"  />
							</el-form-item>
						</el-col>
					</el-row>
				</template>
				<template>
					<el-table-column  width="150" sortable prop="folder" label="Carpeta"  />
					<el-table-column sortable prop="name" label="Nombre"  />
					<el-table-column width="150" sortable prop="size" label="Tamaño"  class-name="align-right"> 
						<template v-slot="{row}">
							{{ row.size | kiloBytes}}
						</template>
					</el-table-column>
					<el-table-column width="200" sortable prop="modTime" label="Ultima Actualización" >
						<template v-slot="{row}">
							{{row.modTime | fechaHora}}
						</template>
					</el-table-column>
					<!-- <el-table-column sortable prop="description" label="Descripción"  /> -->
				</template>
		</mind-layout-table>
		<el-dialog
			title="Subir Audios" :close-on-click-modal="false"
			:visible.sync="dialogVisible"
			width="30%"
			>
				<el-upload
					ref="upload" multiple
					class="upload-demo"
					action="api/sounds/custom/" :on-error="handlerSendError" :on-change="fetch"
					:auto-upload="false" >
					<el-button size="small" type="primary">Selecionar Audio(s)</el-button>
				</el-upload>
			<span slot="footer" class="dialog-footer">
				<el-button type="primary" @click="onSubmitUpload()">Subir</el-button>
			</span>
		</el-dialog>
	</div>
</template>

<script>
import store from '@/store/sounds'
import {Rest} from '@/../modules/mind-core-vue'

export default {
  async created() {
		store.idAgencia = 1

		this.api = new Rest({
			uri: `api/sounds`, 
			state: store.data,
			key: 'name'})
		this.fetch()
	},
	computed:{
		ListaRecursos() {
			let lista = []
			if(!store.data.RESOURCE_LIST) {
				return []
			}
			for(const r of store.data.RESOURCE_LIST) {
				lista.push({
					...r,
					fullpath: `${r.folder}/${r.name}`
					})
			}
			return lista
		},
	},
	methods: {
		/**
		 * Elimina el recuros especificado
		 * @param id recurso del elemento a eliminar
		 */
		onDelete(id){
			this.api.Delete(id).catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});
			})
		},
		// //recarga el modulo especificado
		// reload(module) {
		// 	this.api.Post(null, { uri: `${this.api.uri}/reload/${module}`})
		// 		.then(()=> {
		// 			this.$message({
		// 				showClose: true,
		// 				type: 'success',
		// 				message: "Módulo Recargado Correctamente"
		// 			});
		// 		})
		// 		.catch((error) => {
		// 			this.$message({
		// 				showClose: true,
		// 				type: 'error',
		// 				message: error
		// 			});
		// 		})
		// },
		async fetch() {
			this.loading = true
			await this.api.FetchAll({
				filters: this.filtros
			})
			.catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});
			})
			this.loading = false
		},
		resetFiltro() {
			this.filtros = {
				name: '',
				folder: 'custom'
			}
			// this.fetch()
		},
		// async filtrar() {
		// 	this.loading = true
		// 	await this.api.FetchAll({
		// 		filters: this.filtros
		// 	})
		// 	.catch((error)=>{
		// 		this.$message({
		// 			showClose: true,
		// 			type: 'error',
		// 			message: error
		// 		});
		// 	})
		// 	this.loading = false
		// },
		onDownload(m){
			var link = document.createElement("a");
			let uri = `${this.api.uri}/${m.folder}/${m.name}`
			link.download = m.name;
			link.href = uri;
			link.click();
		},
		onSubmitUpload(){
				this.$refs.upload.submit();
		},
		// sendFile(file) {
		// 	return false
		// },
		handlerSendError(e, file) {
			let err = JSON.parse(e.message)
			this.$message({
				title: file,
				showClose: true,
				type: 'error',
				message: `${err.message}`
				// message: e
			});
		},
		// onPlay(){
		// 	console.log('play')

		// }
	},
	filters: {
		fechaHora(value) {
			return value.replace("T", " ").split(".")[0]
		},
		kiloBytes(value) {
			return parseFloat(value / 1000).toFixed(2) + " KB"
		}
	},
	data() {
		return {
			api: null,
			dialogVisible: false,
			uploadFileList: [],
			loading: false,
			filtros: {
				name: null,
				folder: 'custom'
			}
		}
	}
	
}
</script>
<style >
	.el-table .disabled {
    /* background: #f0f9eb; */
		text-decoration: line-through;
		color: rgb(158, 154, 154);
	}

	.align-right .cell {
		text-align: right;
	}
</style>

<style lang="css" scoped>
</style>
